GetLevAddress:
	movea.l	LEVDATA_START,a0
	move.w	Kairi_LevY,d2
	mulu	#LEVSIZE,d2
	mulu	Levels_Wide,d2
	adda.l	d2,a0
	move.w	Kairi_LevX,d2
	mulu	#LEVSIZE,d2
	adda.l	d2,a0
	move.l	a0,LEVDATA_ADDR
	rts

LoadKairi:
	lea	KairiSprite(pc),a0		;load up Kairi's variables
	move.l	a0,CHARSPRITE_ADDR
	lea	Kairi_X(pc),a0
	move.l	a0,CHARX_ADDR
	lea	Kairi_Y(pc),a0
	move.l	a0,CHARY_ADDR
	lea	Kairi_Step(pc),a0
	move.l	a0,CHARSTEP_ADDR
	lea	Kairi_Dir(pc),a0
	move.l	a0,CHARDIR_ADDR
	rts

DrawGameSprite:
	move.l	CHARX_ADDR,a1
	move.w	(a1),d0				;set Kairi's variables, then draw
	move.l	CHARY_ADDR,a1			;Kairi sprite to screen buffer
	move.w	(a1),d1
	movea.l	CHARSPRITE_ADDR,a0
	move.l	CHARSTEP_ADDR,a1
	move.w	(a1),d2
	mulu	#104,d2
	adda.l	d2,a0
	move.l	CHARDIR_ADDR,a1
	move.w	(a1),d2
	mulu	#312,d2
	adda.l	d2,a0
	bsr	PutSpriteBuffer
	rts

EraseGameSprite:
	move.l	CHARX_ADDR,a1
	move.w	(a1),d0				;erase the sprite by drawing the appropriate
	move.l	CHARY_ADDR,a1			;tiles over it (faster than redrawing whole)
	move.w	(a1),d1
	movea.l	LEVDATA_ADDR,a0			;screen
	bsr	EraseSprite
	rts

AnimateSprite:
	move.l	CHARSTEP_ADDR,a1
	cmp.w	#1,(a1)				;variable Kairi_Step sets the state of a sprite
	beq	CharStep1			;for illusion of walking; if Kairi_Step equals:
	cmp.w	#2,(a1)				;0 - normal (standing still)
	beq	CharStep2			;1 - left foot forward
	rts					;2 - right foot forward
CharStep1:
	move.w	#2,(a1)
	rts
CharStep2:
	move.w	#1,(a1)
	rts